package com.bcxin.tenant.domain.v5.eventHandlers;

import com.bcxin.Infrastructures.events.handlers.DomainEventHandlerAbstract;
import com.bcxin.tenant.domain.entities.EmployeeEntity;
import com.bcxin.tenant.domain.events.TenantCredentialChangedValidateEvent;
import com.bcxin.tenant.domain.repositories.EmployeeRepository;
import com.bcxin.tenant.domain.v5.services.TUserService;
import com.bcxin.tenant.domain.v5.services.commands.UserCredentialCommand;
import org.springframework.stereotype.Component;

import java.util.Collection;

@Component
public class V5UserUpdateEventHandler extends DomainEventHandlerAbstract<TenantCredentialChangedValidateEvent> {
    private final TUserService userService;
    private final EmployeeRepository employeeRepository;
    public V5UserUpdateEventHandler(TUserService userService, EmployeeRepository employeeRepository) {
        this.userService = userService;
        this.employeeRepository = employeeRepository;
    }

    @Override
    protected void execute(TenantCredentialChangedValidateEvent event) {
        Collection<EmployeeEntity> employees = this.employeeRepository.getSecurityGuardsByTenantUserId(event.getTenantUserId());
        this.userService.dispatch(UserCredentialCommand.create(employees,event.getName(),event.getData(),event.getNumber()));
    }
}
